//"client" : imdisk -a -t proxy -o shm -o ro -f test_proxy -m Z:
//"server" : devio --dll=proxy.dll;dllopen shm:test_proxy c:\test.e01
//sourcecode for libewf unit here : http://labalec.fr/erwan/?p=1235

library proxy;

uses
  SysUtils,
  Classes,
  windows,
  LibEWFUnit in '..\..\libewf\libewf_client\LibEWFUnit.pas';

{$R *.res}

type
  dllread_proc = function (handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
  dllwrite_proc = function (handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
  dllclose_proc = function (handle:thandle): integer; cdecl;

var
file_handle:thandle;
ewf:TLibEWF;

function SetFilePointerEx (hFile: THandle; lDistanceToMove: int64; lpNewFilePointer: Pointer; dwMoveMethod: DWORD): BOOL; stdcall; external 'kernel32.dll';
function GetFileSizeEx(hFile: THandle; var lpFileSize: Int64): BOOL; stdcall; external 'kernel32.dll' name 'GetFileSizeEx';

function my_read_proc(handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
var
bytes_read:cardinal;
begin
	writeln('Read request - size:'+inttostr(size)+' offset:'+inttostr(offset));
	result:=ewf.libewf_read_random(buf,size,offset);
end;

function my_write_proc(handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
var
bytes_written:cardinal;
begin
  //an EWF container is not meant to be written - open as read only
	writeln('Write request - size:'+inttostr(size)+' offset:'+inttostr(offset));
	//result:=ewf.libewf_write_random(buf,size,offset);
  result:=size;
end;

function my_close_proc(handle:thandle): integer; cdecl;
begin
	writeln('Close request');
	ewf.destroy ;
	result:=0;
end;

function dllopen(filename:pchar; read_only:integer; var dllread:dllread_proc; var dllwrite:dllwrite_proc; var dllclose:dllclose_proc; var size:int64):thandle;cdecl;
var
value:ansistring;
begin
	writeln('File to open: '+ansistring(filename));

	dllread := my_read_proc;
	dllwrite := my_write_proc;
	dllclose := my_close_proc;

  ewf:=TLibEWF.create ;
  if ewf.libewf_open(ansistring(filename),LIBEWF_OPEN_READ )<>0
    then writeln('libewf_open NOK')
    else Writeln('libewf_open OK');
  size:=ewf.libewf_get_media_size;
  writeln('size: '+inttostr(size));

	result:=1;
end;

exports
  dllopen index 1;

begin
end.
